Find the smallest element greater than current element












3














my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question
























  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    Dec 19 '18 at 22:05










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    Dec 19 '18 at 23:20












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    Dec 20 '18 at 3:11
















3














my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question
























  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    Dec 19 '18 at 22:05










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    Dec 19 '18 at 23:20












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    Dec 20 '18 at 3:11














3












3








3







my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question















my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.







algorithms arrays






share|cite|improve this question















share|cite|improve this question













share|cite|improve this question




share|cite|improve this question








edited Dec 20 '18 at 2:41









xskxzr

3,4661730




3,4661730










asked Dec 19 '18 at 22:01









Austin

182




182












  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    Dec 19 '18 at 22:05










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    Dec 19 '18 at 23:20












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    Dec 20 '18 at 3:11


















  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    Dec 19 '18 at 22:05










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    Dec 19 '18 at 23:20












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    Dec 20 '18 at 3:11
















How difficult would this problem be if you had an array of integers, sorted in ascending order?
– gnasher729
Dec 19 '18 at 22:05




How difficult would this problem be if you had an array of integers, sorted in ascending order?
– gnasher729
Dec 19 '18 at 22:05












I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
– xuq01
Dec 19 '18 at 23:20






I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
– xuq01
Dec 19 '18 at 23:20














I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
– xuq01
Dec 20 '18 at 3:11




I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
– xuq01
Dec 20 '18 at 3:11










1 Answer
1






active

oldest

votes


















2














A better solution would be using a balanced binary search tree.

You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






share|cite|improve this answer























    Your Answer





    StackExchange.ifUsing("editor", function () {
    return StackExchange.using("mathjaxEditing", function () {
    StackExchange.MarkdownEditor.creationCallbacks.add(function (editor, postfix) {
    StackExchange.mathjaxEditing.prepareWmdForMathJax(editor, postfix, [["$", "$"], ["\\(","\\)"]]);
    });
    });
    }, "mathjax-editing");

    StackExchange.ready(function() {
    var channelOptions = {
    tags: "".split(" "),
    id: "419"
    };
    initTagRenderer("".split(" "), "".split(" "), channelOptions);

    StackExchange.using("externalEditor", function() {
    // Have to fire editor after snippets, if snippets enabled
    if (StackExchange.settings.snippets.snippetsEnabled) {
    StackExchange.using("snippets", function() {
    createEditor();
    });
    }
    else {
    createEditor();
    }
    });

    function createEditor() {
    StackExchange.prepareEditor({
    heartbeatType: 'answer',
    autoActivateHeartbeat: false,
    convertImagesToLinks: false,
    noModals: true,
    showLowRepImageUploadWarning: true,
    reputationToPostImages: null,
    bindNavPrevention: true,
    postfix: "",
    imageUploader: {
    brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
    contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
    allowUrls: true
    },
    onDemand: true,
    discardSelector: ".discard-answer"
    ,immediatelyShowMarkdownHelp:true
    });


    }
    });














    draft saved

    draft discarded


















    StackExchange.ready(
    function () {
    StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcs.stackexchange.com%2fquestions%2f101806%2ffind-the-smallest-element-greater-than-current-element%23new-answer', 'question_page');
    }
    );

    Post as a guest















    Required, but never shown

























    1 Answer
    1






    active

    oldest

    votes








    1 Answer
    1






    active

    oldest

    votes









    active

    oldest

    votes






    active

    oldest

    votes









    2














    A better solution would be using a balanced binary search tree.

    You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

    Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






    share|cite|improve this answer




























      2














      A better solution would be using a balanced binary search tree.

      You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

      Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






      share|cite|improve this answer


























        2












        2








        2






        A better solution would be using a balanced binary search tree.

        You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

        Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






        share|cite|improve this answer














        A better solution would be using a balanced binary search tree.

        You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

        Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.







        share|cite|improve this answer














        share|cite|improve this answer



        share|cite|improve this answer








        edited Dec 19 '18 at 22:59

























        answered Dec 19 '18 at 22:10









        narek Bojikian

        3466




        3466






























            draft saved

            draft discarded




















































            Thanks for contributing an answer to Computer Science Stack Exchange!


            • Please be sure to answer the question. Provide details and share your research!

            But avoid



            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.


            Use MathJax to format equations. MathJax reference.


            To learn more, see our tips on writing great answers.





            Some of your past answers have not been well-received, and you're in danger of being blocked from answering.


            Please pay close attention to the following guidance:


            • Please be sure to answer the question. Provide details and share your research!

            But avoid



            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.


            To learn more, see our tips on writing great answers.




            draft saved


            draft discarded














            StackExchange.ready(
            function () {
            StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcs.stackexchange.com%2fquestions%2f101806%2ffind-the-smallest-element-greater-than-current-element%23new-answer', 'question_page');
            }
            );

            Post as a guest















            Required, but never shown





















































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown

































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown







            Popular posts from this blog

            Morgemoulin

            Scott Moir

            Souastre